Subject: Re: [PATCH net-next 0/6] mlxsw: Add extended ACK for EMADs

From: Ido Schimmel <[email-masked]>
Date: Tue, 5 Nov 2019 01:20:36 +0200

On Mon, Nov 04, 2019 at 02:44:19PM -0800, Jakub Kicinski wrote:
> On Mon, 4 Nov 2019 23:04:50 +0200, Ido Schimmel wrote:
> > On Mon, Nov 04, 2019 at 12:39:54PM -0800, Jakub Kicinski wrote:
> > > On Sun,  3 Nov 2019 10:35:48 +0200, Ido Schimmel wrote:  
> > > > From: Ido Schimmel <[email-masked]>
> > > > 
> > > > Ethernet Management Datagrams (EMADs) are Ethernet packets sent between
> > > > the driver and device's firmware. They are used to pass various
> > > > configurations to the device, but also to get events (e.g., port up)
> > > > from it. After the Ethernet header, these packets are built in a TLV
> > > > format.
> > > > 
> > > > Up until now, whenever the driver issued an erroneous register access it
> > > > only got an error code indicating a bad parameter was used. This patch
> > > > set from Shalom adds a new TLV (string TLV) that can be used by the
> > > > firmware to encode a 128 character string describing the error. The new
> > > > TLV is allocated by the driver and set to zeros. In case of error, the
> > > > driver will check the length of the string in the response and print it
> > > > to the kernel log.
> > > > 
> > > > Example output:
> > > > 
> > > > mlxsw_spectrum 0000:03:00.0: EMAD reg access failed (tid=a9719f9700001306,reg_id=8018(rauhtd),type=query,status=7(bad parameter))
> > > > mlxsw_spectrum 0000:03:00.0: Firmware error (tid=a9719f9700001306,emad_err_string=inside er_rauhtd_write_query(), num_rec=32 is over the maximum number of records supported)  
> > > 
> > > Personally I'm not a big fan of passing unstructured data between user
> > > and firmware. Not having access to the errors makes it harder to create
> > > common interfaces by inspecting driver code.  
> > 
> > I don't understand the problem. If we get an error from firmware today,
> > we have no clue what the actual problem is. With this we can actually
> > understand what went wrong. How is it different from kernel passing a
> > string ("unstructured data") to user space in response to an erroneous
> > netlink request? Obviously it's much better than an "-EINVAL".
> 
> The difference is obviously that I can look at the code in the kernel
> and understand it. FW code is a black box. Kernel should abstract its
> black boxiness away.

But FW code is still code and it needs to be able to report errors in a
way that will aid us in debugging when problems occur. I want meaningful
errors from applications regardless if I can read their code or not.

> 
> > Also, in case it was not clear, this is a read-only interface and only
> > from firmware to kernel. No hidden knobs or something fishy like that.
> 
> I'm not saying it's fishy, I'm saying it's way harder to refactor code
> if some of the user-visible outputs are not accessible (i.e. hidden in
> a binary blob).

Not sure I understand which code you're referring to? The error print
statement?

>
> > > Is there any precedent in the tree for printing FW errors into the logs
> > > like this?  
> > 
> > The mlx5 driver prints a unique number for each firmware error. We tried
> > to do the same in switch firmware, but it lacked the infrastructure so
> > we decided on this solution instead. It achieves the same goal, but in a
> > different way.
> 
> FWIW nfp FW also passes error numbers to the driver and based on that
> driver makes decisions and prints errors of its own choosing. The big
> difference being you can see all the relevant errors by looking at
> driver code.

This is done by mlxsw as well. See:
$ vi drivers/net/ethernet/mellanox/mlxsw/emad.h +50

But by far the most common error is "bad parameter" in which case we
would like to know exactly what is "bad" and why.

Anyway, it's already tomorrow here, so I'll be back in a few hours (IOW:
expect some delay).